(*
    NkV - Graphic Viewer
    Copyright (C) 1998-2003 Nobuyuki Honda (Ferdia) <ferdia@imasy.or.jp>

    Compiler: Delphi 3.01a
*)

// todo: top down bmp support

program NkV;

uses
  Windows, Messages, ShellAPI,
  DIBLib, SPIUtil, NkVImage,
  SUtil, SForm, SimpleList, ConfFile, KeyTable, SMenu;

{$R *.RES}
{$R nkvres.res}
{$I nkv.inc}

const
  AppName = 'NkV';
  Version = '0.3.5 (2003-11-11)';
  Copyright = 'Copyright (C) 1999-2003 Nobuyuki Honda (Ferdia)'#13#10#13#10+
    'This software is provided under the zlib/libpng license.'#13#10;

  IDM_FIT           = 1;
  IDM_ZOOMIN        = 2;
  IDM_ZOOMOUT       = 3;
  IDM_INFO          = 4;
  IDM_WALLP         = 5;
  IDM_WALLPTILE     = 6;
  IDM_STAYONTOP     = 7;
  IDM_ABOUT         = 8;
  IDM_FULLSCREEN    = 9;
  IDM_STRETCH       = 10;
  IDM_READPREV      = 20;
  IDM_READNEXT      = 21;
  IDM_SMOOTHZOOMIN  = 22;
  IDM_SMOOTHZOOMOUT = 23;
  IDM_PLUGINLIST    = 24;
  IDM_HIDEBORDER    = 25;
  IDM_REFRESHFILELIST = 26;
  IDM_READPREVFILE  = 27;
  IDM_READNEXTFILE  = 28;
  IDM_SCROLLTOP     = 29;
  IDM_SCROLLBOTTOM  = 30;
  IDM_SCROLLTOPBOTTOM = 31;
  IDM_SCROLLUP      = 32;
  IDM_SCROLLDOWN    = 33;
  IDM_SCROLLLEFT    = 34;
  IDM_SCROLLRIGHT   = 35;
  IDM_ARCHIVEFILELIST = 90;
  IDM_EXIT          = 99;
  IDM_ZOOMSTART     = 1000;
  IDM_ZOOMEND       = 1999;
  IDM_ZOOM25        = 1025;
  IDM_ZOOM50        = 1050;
  IDM_ZOOM100       = 1100;
  IDM_ZOOM150       = 1150;
  IDM_ZOOM200       = 1200;
  IDM_ZOOM300       = 1300;
  IDM_ZOOM400       = 1400;
  IDM_ZOOM800       = 1800;
  IDM_PLUGINSETTING_START = 4000;
  IDM_PLUGINSETTING_END = 4999;

  Cmds: array[0..31] of TCmd = (
    (Name: 'FitWindow'; Caption: '&Fit Window'; Id: IDM_FIT),
    (Name: 'ZoomIn'; Caption: 'Zoom In (&+)'; Id: IDM_ZOOMIN),
    (Name: 'ZoomOut'; Caption: 'Zoom Out (&-)'; Id: IDM_ZOOMOUT),
    (Name: 'SmoothZoomIn'; Caption: 'Smooth Zoom In'; Id: IDM_SMOOTHZOOMIN),
    (Name: 'SmoothZoomOut'; Caption: 'Smooth Zoom Out'; Id: IDM_SMOOTHZOOMOUT),
    (Name: 'PicInfo'; Caption: 'Picture &Information'; Id: IDM_INFO),
    (Name: 'FullScreen'; Caption: 'Full &Screen'; Id: IDM_FULLSCREEN),
    (Name: 'StretchMode'; Caption: '&Stretch Mode'; Id: IDM_STRETCH),
    (Name: 'HideBorder'; Caption: 'Hide &Border'; Id: IDM_HIDEBORDER),
    (Name: 'StayOnTop'; Caption: 'Stay &On Top'; Id: IDM_STAYONTOP),
    (Name: 'Zoom50'; Caption: 'Zoom &50%'; Id: IDM_ZOOM50),
    (Name: 'Zoom100'; Caption: 'Zoom &100%'; Id: IDM_ZOOM100),
    (Name: 'Zoom150'; Caption: 'Zoom 150%(&Q)'; Id: IDM_ZOOM150),
    (Name: 'Zoom200'; Caption: 'Zoom &200%'; Id: IDM_ZOOM200),
    (Name: 'Zoom300'; Caption: 'Zoom &300%'; Id: IDM_ZOOM300),
    (Name: 'Zoom400'; Caption: 'Zoom &400%'; Id: IDM_ZOOM400),
    (Name: 'Zoom800'; Caption: 'Zoom &800%'; Id: IDM_ZOOM800),
    (Name: 'NextImage'; Caption: '&Next Image'; Id: IDM_READNEXT),
    (Name: 'PrevImage'; Caption: '&Previous Image'; Id: IDM_READPREV),
    (Name: 'NextFile'; Caption: 'N&ext File'; Id: IDM_READNEXTFILE),
    (Name: 'PrevFile'; Caption: 'P&revious File'; Id: IDM_READPREVFILE),
    (Name: 'RefreshFileList'; Caption: 'Reload FileList'; Id: IDM_REFRESHFILELIST),
    (Name: 'ScrollTop'; Caption: 'Scroll Top'; Id: IDM_SCROLLTOP),
    (Name: 'ScrollBottom'; Caption: 'Scroll Bottom'; Id: IDM_SCROLLBOTTOM),
    (Name: 'ScrollTopBottom'; Caption: 'Scroll Top/Bottom'; Id: IDM_SCROLLTOPBOTTOM),
    (Name: 'ScrollUp'; Caption: 'Scroll Up'; Id: IDM_SCROLLUP),
    (Name: 'ScrollDown'; Caption: 'Scroll Down'; Id: IDM_SCROLLDOWN),
    (Name: 'ScrollLeft'; Caption: 'Scroll Left'; Id: IDM_SCROLLLEFT),
    (Name: 'ScrollRight'; Caption: 'Scroll Right'; Id: IDM_SCROLLRIGHT),
    (Name: 'PluginList'; Caption: 'Plugin &List'; Id: IDM_PLUGINLIST),
    (Name: 'About'; Caption: '&About'; Id: IDM_ABOUT),
    (Name: 'Exit'; Caption: 'E&xit'; Id: IDM_EXIT)
  );

  DefaultKeys: array[0..79] of string = (
    'Enter', 'FullScreen',
    'Esc', 'Exit',
    'Space', 'ScrollTopBottom',
    'PgUp', 'ZoomIn',
    'PgDn', 'ZoomOut',
    'End', 'ScrollBottom',
    'Home', 'ScrollTop',
    'Left', 'ScrollLeft',
    'Up', 'ScrollUp',
    'Right', 'ScrollRight',
    'Down', 'ScrollDown',
    'Num1', 'Zoom100',
    'Num2', 'Zoom200',
    'Num3', 'Zoom300',
    'Num4', 'Zoom400',
    'Num5', 'Zoom50',
    'Num8', 'Zoom800',
    '1', 'Zoom100',
    '2', 'Zoom200',
    '3', 'Zoom300',
    '4', 'Zoom400',
    '5', 'Zoom50',
    '8', 'Zoom800',
    'B', 'PrevImage',
    'S-B', 'PrevFile',
    'C-B', 'HideBorder',
    'N', 'NextImage',
    'S-N', 'NextFile',
    'F', 'FitWindow',
    'I', 'PicInfo',
    'P', 'PrevImage',
    'C-P', 'PluginList',
    'Q', 'Zoom150',
    'C-R', 'RefreshFileList',
    'S', 'StretchMode',
    'T', 'StayOnTop',
    'X', 'ZoomOut',
    'S-X', 'SmoothZoomOut',
    'Z', 'ZoomIn',
    'S-Z', 'SmoothZoomIn'
  );

  MenuTable: array[0..24] of Integer = (
    IDM_READPREV,
    IDM_READNEXT,
    IDM_READPREVFILE,
    IDM_READNEXTFILE,
    -1,
    IDM_FIT,
    IDM_STRETCH,
    -1,
    IDM_ZOOMIN,
    IDM_ZOOMOUT,
    IDM_ZOOM50,
    IDM_ZOOM100,
    IDM_ZOOM150,
    IDM_ZOOM200,
    IDM_ZOOM300,
    IDM_ZOOM400,
    -1,
    IDM_FULLSCREEN,
    IDM_STAYONTOP,
    IDM_HIDEBORDER,
    -1,
    IDM_INFO,
    -1,
    IDM_ABOUT,
    IDM_EXIT
  );

  Scroll = 16; // J[\gp̃XN[
  ZoomTable: array [0..15] of Integer =
    (12, 25, 50, 66, 100, 125, 150, 200, 300, 400, 500, 600, 700, 800, 1200, 1600);

  WallpaperFile = 'wallpaper.bmp';
  PluginListFile = 'pluginlist';
  KeyMapFile = 'keymap';
  ConfigFile = 'config';

//resourcestring

  err_cantwrite      = 'Cannot write file.';
  err_unknownformat  = 'Unknown format.';
  //err_notfoundinarc  = 'Loadable file not found in archive file.';

type
  TFileList = class(TObject)
  private
    FItems: TSimpleList;
    function Get(Index: Integer): PFileItem;
    function GetItemCount: Integer;
  public
    CurPos: Integer;
    constructor Create;
    destructor Destroy; override;
    procedure AddItem(const Item: TFileItem);
    procedure Sort;
    procedure Clear;
    property Items[Index: Integer]: PFileItem read Get; default;
    property ItemCount: Integer read GetItemCount;
    procedure LoadFromDirectory(const FileName: string);
    procedure LoadFromArchive(PluginHandle: THandle; const FileName: string);
  end;

  TMainWindow = class(TSForm)
  private
    oldpt: TPoint; /////
    SaveWP: TWindowPlacement;
    SaveWS: Integer;
    FFullScreen: Boolean;
    FBorder: Boolean;
    procedure SetFullScreen(Value: Boolean);
    procedure SetBorder(Value: Boolean);
    function ReadFile(const FileName: string; const FileItem: PFileItem): Integer;
    function ReadPrevFileFromArchive(const FileName: string; FileList: TFileList): Integer;
    function ReadNextFileFromArchive(const FileName: string; FileList: TFileList): Integer;
  public
    Left, Top: Integer;
    NormalCursor: HCURSOR;
    GrabCursor: HCURSOR;
    Stretch: Boolean;
    DispWidth: Integer;         // \
    DispHeight: Integer;        // \
    Zoom: Integer;              // g嗦(%)
    property FullScreen: Boolean read FFullScreen write SetFullScreen;
    property Border: Boolean read FBorder write SetBorder;
    procedure ShowAbout;
    procedure SetTitle;
    procedure FitWindow;
    procedure ZoomImage(Value: Integer);
    procedure PopupMenu;
    procedure ScrollImage(x, y: Integer);
    procedure SetPictureInfoItem(hwndDlg: HWND);
    function ReadNewFile(const FileName: string; LastFileInArc: Boolean): Integer;
    procedure ReadNextFile(ForceNextFile: Boolean);
    procedure ReadPrevFile(ForcePrevFile: Boolean);
    procedure OnPaint;
    procedure OnCommand(Cmd: Integer);
    procedure OnDropFiles(hDrop: HDROP);
    procedure WndProc(var Message: TMessage); override;
  end;

var
  ProfDir: string;

  MainWindow: TMainWindow;
  Image: TNkVImage;
  KeyTbl: TKeyTable;
  FileList: TFileList;
  ArcFileList: TFileList;
  TmpArcFileList: TFileList;

  KeepViewPositon: Boolean = False;

  InfoDlg: HWND;
  InfoDlgIcon: HICON; // InfoDlg̃ACR

//  SetLayeredWindowAttributes: function(wnd: HWND; crKey: DWORD;
//    bAlpha: BYTE; dwFlag: DWORD): Boolean; stdcall;

function CommaStr(Value: Integer): string;
var
  s: string;
  nf: TNumberFmt;
  buf: array[0..255] of Char;
begin
  nf.NumDigits := 0;
  nf.LeadingZero := 0;
  nf.Grouping := 3;
  nf.lpDecimalSep := '.';
  nf.lpThousandSep := ',';
  nf.NegativeOrder := 1;
  Str(Value, s);
  GetNumberFormat(LOCALE_USER_DEFAULT, 0, PChar(s), @nf, buf, SizeOf(buf));
  Result := buf;
end;
{
var
  s: string;
  i: Integer;
begin
  Str(Value, s);
  Result := '';
  for i := 1 to Length(s) do begin
    Result := Result + s[i];
    if ((Length(s) - i) mod 3 = 0) and (Length(s) <> i) then
      Result := Result + ',';
  end;
end;
}

// exploreroCg\
function IntToKBStr(Value: Integer): string;
var
  u, s: string;
begin
  if Value < 1024 then
  begin
    Result := IntToStr(Value) + ' bytes';
    Exit;
  end;
  if Value >= 1024*1024*1024 then
  begin
    Value := (Value div 1024 div 1024)*100 div 1024;
    u := ' GB';
  end
  else if Value >= 1024*1024 then
  begin
    Value := (Value div 1024)*100 div 1024;
    u := ' MB';
  end
  else if Value >= 1024 then
  begin
    Value := Value*100 div 1024;
    u := ' KB';
  end
  else begin
    Value := Value*100;
    u := ' bytes';
  end;
  Str(Value, s);
  if Value >= 10000 then
    Result := s[1]+s[2]+s[3]
  else if Value >= 1000 then
    Result := s[1]+s[2]+'.'+s[3]
  else if Value >= 100 then
    Result := s[1]+'.'+s[2]+s[3]
  else
    Result := s;
  Result := Result + u;
end;
{
var
  c: Currency;
  u: string;
  a: Integer;
begin
  if Value >= 1024*1024*1024 then begin
    c := Value / 1024 / 1024 / 1024;
    u := ' GB';
  end
  else if Value >= 1024*1024 then begin
    c := Value / 1024 / 1024;
    u := ' MB';
  end
  else if Value >= 1024 then begin
    c := Value / 1024;
    u := ' KB';
  end
  else begin
    c := Value;
    u := ' bytes';
  end;
  if c >= 100 then
    a := 0
  else if c >= 10 then
    a := 1
  else
    a := 2;
  Str(c :0 :a, Result);
  Result := Result + u;
end;
}

function GetLongFileName(const FileName: string): string;
var
  buf: array [0..MAX_PATH] of Char;
  p: PChar;
  h: THandle;
  FindData: TWin32FindData;
begin
  Result := '';
  GetFullPathName(PChar(FileName), SizeOf(buf), buf, p);
  while True do begin
    h := FindFirstFile(buf, FindData);
    if h = INVALID_HANDLE_VALUE then begin
      Result := string(buf) + Result;
      Exit;
    end;
    Windows.FindClose(h);
    if buf[Length(buf)-1] = ':' then begin
      Result := string(buf) + Result;
      Exit;
    end;
    // '.' 狤L(@Win95a)??
    if string(FindData.cFileName) = '.' then begin
      Result := string(buf) + Result;
      Exit;
    end;
    Result := '\' + string(FindData.cFileName) + Result;
    GetFullPathName(buf, SizeOf(buf), buf, p);
    if p <> nil then
      if ((p-1)^ = '\') then (p-1)^ := #0
  end;
end;

// FileTime(UTC) ftHgP[̓𓾂
function FileTimeToLocalTimeStr(const FileTime: TFileTime): string;
var
  buf: array[0..1023] of Char;
  st: TSystemTime;
  ft: TFileTime;
begin
  if (FileTime.dwLowDateTime = 0) and (FileTime.dwHighDateTime = 0) then
  begin
    Result := 'Unknown';
    Exit;
  end;
  FileTimeToLocalFileTime(FileTime, ft);
  FileTimeToSystemTime(ft, st);
  GetDateFormat(LOCALE_USER_DEFAULT, DATE_LONGDATE, @st, nil, buf, SizeOf(buf));
  Result := buf;
  GetTimeFormat(LOCALE_USER_DEFAULT, 0, @st, nil, buf, SizeOf(buf));
  Result := Result + ' ' + buf;
end;

// vOCTďꏊt@Cɏo
// return : IOResult
function MakePluginListFile: Integer;
var
  hf: THandle;
  fd: TWin32FindData;
  F: Text;
  s, path: string;
begin
  path := GetPluginPath;
  // ꏊ̎擾Ɏs exe ƓfBNgT
  if path = '' then
    path := ExtractFilePath(ParamStr(0));
  if (path[Length(path)] <> '\') or IsDBCSLeadByte(Byte(path[Length(path)-1])) then
    path := path + '\';

  s := '';
  hf := FindFirstFile(PChar(path + '*.spi'), fd);
  if hf <> INVALID_HANDLE_VALUE then begin
    try
      repeat
        s := s + path + fd.cFileName + #13#10;
      until FindNextFile(hf, fd) <> True;
    finally
      Windows.FindClose(hf);
    end;
  end;

  AssignFile(F, ProfDir + PluginListFile);
  {$I-}
  Rewrite(F);
  {$I+}
  Result := IOResult;
  if Result = 0 then
  begin
    Write(F, s);
    CloseFile(F);
  end;
end;

// SPI ̃Xgǂ
// return: IOResult
function LoadPluginListFile: Integer;
var
  F: Text;
  p: PChar;
  s: string;
  buf: array[0..1023] of Char;
begin
  AssignFile(F, ProfDir + PluginListFile);
  SetTextBuf(F, buf);
  {$I-}
  Reset(F);
  {$I+}
  Result := IOResult;
  if Result <> 0 then
    Exit;

  while not Eof(F) do
  begin
    Readln(F, s);
    if s = '' then
      Continue;
    if s[1] = '#' then
      Continue;
    GetMem(p, Length(s)+1);
    Move(PChar(s)^, p^, Length(s)+1); // #0܂ŃRs[
    Image.PluginList.Add(p);
  end;
  CloseFile(F);
end;

function SetWallPaper(TileFlg: Boolean): Integer;
var
  F: File;
  s: string;
  bfh: TBitmapFileHeader;
  bmisize: Integer;
  hkResult: HKEY;
  data: array[0..MAX_PATH] of Char;
begin
  s := ProfDir+WallpaperFile;
  AssignFile(F, s);
  {$I-}
  ReWrite(F, 1);
  {$I+}
  Result := IOResult;
  if Result <> 0 then Exit;

  with Image do
  begin
    bmisize := SizeOf(BitmapInfo.bmiHeader);
    if BitmapInfo.bmiHeader.biBitCount <= 8 then
      Inc(bmisize, (1 shl BitmapInfo.bmiHeader.biBitCount) * SizeOf(TRGBQUAD));
    with bfh do
    begin
      bfType := byte('B') + byte('M') shl 8;
      bfSize := SizeOf(bfh)+bmisize+MemSize;
      bfReserved1 := 0;
      bfReserved2 := 0;
      bfOffBits  := SizeOf(bfh)+bmisize;
    end;
    BlockWrite(F, bfh, SizeOf(bfh));
    BlockWrite(F, BitmapInfo, bmisize);
    BlockWrite(F, pBits^, MemSize);
  end;
  CloseFile(F);

  if TileFlg then data := '1' else data := '0';
  if RegOpenKeyEx(HKEY_CURRENT_USER, 'Control Panel\desktop', 0, KEY_WRITE, hkResult) = ERROR_SUCCESS then
  begin
    RegSetValueEx(hkResult, 'TileWallPaper', 0, REG_SZ, @data, 1);
    RegCloseKey(hkResult);
  end;

  SystemParametersInfo(SPI_SETDESKWALLPAPER, 0, PChar(s),
    SPIF_UPDATEINIFILE or SPIF_SENDWININICHANGE);
end;

procedure SPIErrorMsgBox(const FileName: string; SPIError: TSPIError);
var
  s: string;
  buf: array[0..MAX_PATH] of Char;
  Parent: HWND;
begin
  GetModuleFileName(SPIError.Handle, buf, SizeOf(buf));
  if (SPIError.Code >= 0) and (SPIError.Code <= High(SpiErrMsg)) then
    s := SpiErrMsg[SPIError.Code]
  else
    s := 'unknown error';
  s := FileName + #13#10 + s + ' (code=' + IntToStr(SPIError.Code) + ')'#13#10'Plug-in: '+buf;
  if IsWindowVisible(MainWindow.Handle) then
    Parent := MainWindow.Handle
  else
    Parent := GetDesktopWindow;
  MessageBox(Parent, PChar(s), AppName, MB_ICONEXCLAMATION);
end;

function GetNextZoom(zoom: Integer): Integer;
var
  i: Integer;
begin
  Result := zoom;
  for i := 0 to High(ZoomTable) do
  begin
    if ZoomTable[i] > zoom then
    begin
      Result := ZoomTable[i];
      Exit;
    end;
  end;
end;

function GetPrevZoom(zoom: Integer): Integer;
var
  i: Integer;
begin
  Result := zoom;
  for i := High(ZoomTable) downto 0 do
  begin
    if ZoomTable[i] < zoom then
    begin
      Result := ZoomTable[i];
      Exit;
    end;
  end;
end;

{  Picture Information Dialog Proc }

function InfoDlgProc(hwndDlg: HWND; Msg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
begin
  Result := LRESULT(True);
  case Msg of
    WM_INITDIALOG:
      MainWindow.SetPictureInfoItem(hwndDlg);
    WM_COMMAND:
      case LOWORD(wParam) of
        IDOK, IDCANCEL: SendMessage(hwndDlg, WM_SYSCOMMAND, SC_CLOSE, 0);
      end;
    WM_DRAWITEM:
      if wParam = IDC_ICON then
        DrawIcon(PDrawItemStruct(lParam).hDC, 0, 0, InfoDlgIcon);
    WM_CLOSE:
      begin
        if InfoDlgIcon <> 0 then DestroyIcon(InfoDlgIcon);
        DestroyWindow(hwndDlg);
      end;
  else
    Result := 0;
  end;
end;

{ TFileList }

constructor TFileList.Create;
begin
  FItems := TSimpleList.Create;
end;

destructor TFileList.Destroy;
begin
  Clear;
  FItems.Free;
end;

procedure TFileList.Clear;
var
  i: Integer;
begin
  for i := 0 to FItems.Count - 1 do
    Dispose(PFileItem(FItems[i]));
  FItems.Clear;
end;

function TFileList.Get(Index: Integer): PFileItem;
begin
  Result := PFileItem(FItems[Index]);
end;

function TFileList.GetItemCount: Integer;
begin
  Result := FItems.Count;
end;

procedure TFileList.AddItem(const Item: TFileItem);
var
  p: PFileItem;
begin
  New(p);
  p^ := Item;
  FItems.Add(p);
end;

function FileListCompare(Item1, Item2: Pointer): Integer;
begin
  Result := lstrcmp(PFileItem(Item1).FileName, PFileItem(Item2).FileName);
end;

procedure TFileList.Sort;
begin
  FItems.Sort(FileListCompare);
end;

// t@CfBNg̃t@CXg擾
procedure TFileList.LoadFromDirectory(const FileName: string);
var
  h: THandle;
  FindData: TWin32FindData;
  path, s: string;
  Item: TFileItem;
  i: Integer;
begin
  Clear;
  path := ExtractFilePath(FileName);
  s := path + '*.*';
  h := FindFirstFile(PChar(s), FindData);
  if h = INVALID_HANDLE_VALUE then
    Exit;
  while FindNextFile(h, FindData) = True do
  begin
    if (FindData.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) = 0 then
    begin
      lstrcpyn(Item.FileName, FindData.cFileName, SizeOf(Item.FileName));
      Item.IsImage := True; // t@C͉摜t@CƂ݂Ȃ
      AddItem(Item);
    end;
  end;
  Windows.FindClose(h);
  Sort;
  // ̃t@C̃Xg̈ʒuCurPosɃZbg
  for i := 0 to FItems.Count - 1 do
  begin
    if path + Items[i].FileName = filename then
    begin
      CurPos := i;
      Break;
    end;
  end;
end;

procedure TFileList.LoadFromArchive(PluginHandle: THandle; const FileName: string);
var
  p, pi: PFileItem;
  SPIError: TSPIError;
begin
  SPIError.Code  := GetFileListFromArchive(PluginHandle, FileName, pi); // piFileItem̃Xg
  SPIError.Handle := PluginHandle;
  if SPIError.Code <> 0 then
  begin
    SpiErrorMsgBox(FileName, SPIError);
    Exit;
  end;
  if pi = nil then
    Exit;
  Clear;
  p := pi;
  while p.FileName <> '' do
  begin
    AddItem(p^);
    Inc(p);
  end;
  FreeMem(pi);
  Sort;
end;

{ TMainWindow }

function TMainWindow.ReadFile(const FileName: string; const FileItem: PFileItem): Integer;
var
  oldCursor: HCURSOR;
  l, t, w, h: Integer;
begin
  w := Image.Width;
  h := Image.Height;
  l := Left;
  t := Top;

  if FileItem = nil then
  begin
    oldCursor := SetCursor(LoadCursor(0, IDC_WAIT));
    Result := Image.LoadFromFile(FileName);
    SetCursor(oldCursor);
  end
  else if FileItem.IsImage then
  begin
    oldCursor := SetCursor(LoadCursor(0, IDC_WAIT));
    Result := Image.LoadFromArchive(FileName, FileItem);
    SetCursor(oldCursor);
  end
  else
    Result := nilfUnknown;

  if Image.SPIError.Code <> 0 then
    SPIErrorMsgBox(FileName, Image.SPIError);

  if Result = 0 then
  begin
    if KeepViewPositon and (Image.Width = w) and (Image.Height = h) then
    begin
      Left := l;
      Top := t;
    end
    else begin
      Left := 0;
      Top := 0;
    end;
    if Zoom = 0 then Zoom := 100;
    SetTitle;
    DispWidth := Image.Width * Zoom div 100;
    DispHeight := Image.Height * Zoom div 100;
    if not (Stretch or FullScreen or IsZoomed(Handle)) then
      FitWindow;
    if IsWindow(InfoDlg) then
      SendMessage(InfoDlg, WM_INITDIALOG, 0, 0);
    InvalidateRect(Handle, nil, False);
    UpdateWindow(Handle);
  end
  else if FileItem <> nil then
    FileItem.IsImage := False;
end;

function TMainWindow.ReadNextFileFromArchive(const FileName: string; FileList: TFileList): Integer;
var
  i: Integer;
begin
  Result := -1;
  for i := FileList.CurPos + 1 to FileList.ItemCount - 1 do
  begin
    Result := ReadFile(FileName, FileList[i]);
    if Result = 0 then
    begin
      FileList.CurPos := i;
      Break;
    end;
  end;
end;

function TMainWindow.ReadPrevFileFromArchive(const FileName: string; FileList: TFileList): Integer;
var
  i: Integer;
begin
  Result := -1;
  for i := FileList.CurPos - 1 downto 0 do
  begin
    Result :=  ReadFile(FileName, FileList[i]);
    if Result = 0 then
    begin
      FileList.CurPos := i;
      Break;
    end;
  end;
end;

// LastFileInArc: TrueȂA[JCu̍Ō̃t@Cǂ
function TMainWindow.ReadNewFile(const FileName: string; LastFileInArc: Boolean): Integer;
var
  i: Integer;
begin
  Result := ReadFile(FileName, nil);
  // A[JCut@CXg擾Ēgǂł݂
  if Result = nilfArchive then
  begin
    TmpArcFileList.LoadFromArchive(Image.hAM, FileName);
    if LastFileInArc then
    begin
      TmpArcFileList.CurPos := TmpArcFileList.ItemCount;
      Result := ReadPrevFileFromArchive(FileName, TmpArcFileList)
    end else
    begin
      TmpArcFileList.CurPos := -1;
      Result := ReadNextFileFromArchive(FileName, TmpArcFileList);
    end;
    if Result = 0 then
    begin
      ArcFileList.Clear;
      for i := 0 to TmpArcFileList.ItemCount - 1 do
        ArcFileList.AddItem(TmpArcFileList[i]^);
      ArcFileList.CurPos := TmpArcFileList.CurPos;
      TmpArcFileList.Clear;
    end else
      Image.FreeAM;
  end;
end;

procedure TMainWindow.ReadNextFile(ForceNextFile: Boolean);
var
  path, filename: string;
  i, r: Integer;
begin
  if Image.hAM = 0 then
  begin
    path := ExtractFilePath(Image.FileName);
    filename := Image.FileName;
  end else
  begin
    if not ForceNextFile then
    begin
      r := ReadNextFileFromArchive('', ArcFileList);
      if r = 0 then
        Exit;
    end;
    path := ExtractFilePath(Image.ArcFileName);
    filename := Image.ArcFileName;
  end;

  // FileListȂfBNg
  if FileList.ItemCount = 0 then
    FileList.LoadFromDirectory(filename);

  // ݒn
  for i := FileList.CurPos + 1 to FileList.ItemCount - 1 do
  begin
    if FileList[i].IsImage then
    begin
      if ReadNewFile(Path + FileList[i].FileName, False) = 0 then
      begin
        FileList.CurPos := i;
        Break;
      end else
        FileList[i].IsImage := False;
    end;
  end;
end;

procedure TMainWindow.ReadPrevFile(ForcePrevFile: Boolean);
var
  path, filename: string;
  i, r: Integer;
begin
  if Image.hAM = 0 then
  begin
    path := ExtractFilePath(Image.FileName);
    filename := Image.FileName;
  end else
  begin
    if not ForcePrevFile then
    begin
      r := ReadPrevFileFromArchive('', ArcFileList);
      if r = 0 then
        Exit;
    end;
    path := ExtractFilePath(Image.ArcFileName);
    filename := Image.ArcFileName;
  end;

  // FileListȂfBNg
  if FileList.ItemCount = 0 then
    FileList.LoadFromDirectory(filename);

  // ݒnO
  for i := FileList.CurPos - 1 downto 0 do
  begin
    if FileList[i].IsImage then
    begin
      if ReadNewFile(Path + PFileItem(FileList[i]).FileName, not ForcePrevFile) = 0 then
      begin
        FileList.CurPos := i;
        Break;
      end else
        FileList[i].IsImage := False;
    end;
  end;
end;

procedure TMainWindow.SetTitle;
var
  s, ss: string;
begin
  with Image do
  begin
    if Stretch then
      s := 'Stretch Mode'
    else
      s := IntToStr(Zoom) + '%';
    if hAM = 0 then
      ss := ExtractFileName(FileName)
    else
      ss := ExtractFileName(ArcFileName) + '/' + FileName;
    SetWindowText(Handle, PChar(ss+' ('+IntToStr(Width)+'x'+IntToStr(Height)+'x'+
      IntToStr(ColorDepth)+') '+s+' - '+AppName));
  end;
end;

procedure TMainWindow.PopupMenu;
var
  Menu, WallPMenu, PluginMenu: TSPopupMenu;
  i, wi: Integer;
begin
  Menu := TSPopupMenu.Create;
  KeyTbl.MenuHandle := Menu.Handle;
  KeyTbl.GenerateMenu(MenuTable);

  WallPMenu := TSPopupMenu.Create;
  WallPMenu.AppendItem(IDM_WALLP, '&Normal');
  WallPMenu.AppendItem(IDM_WALLPTILE, '&Tile');

  PluginMenu := TSPopupMenu.Create;
  for i := 0 to Image.PluginList.Count - 1 do
    PluginMenu.AppendItem(IDM_PLUGINSETTING_START+i, Image.PluginList[i]);

  wi := Menu.IndexOfItem(IDM_INFO);
  Menu.InsertItem(WallPMenu.Handle, wi, 'Set As &Wallpaper');
  Menu.InsertItem(WallPMenu.Handle, wi+1, '-');
  i := Menu.IndexOfItem(IDM_ABOUT);
  Menu.InsertItem(PluginMenu.Handle, i, 'Plug-in Setting');
  Menu.InsertItem(PluginMenu.Handle, i+1, '-');

  if not Image.Loaded then
  begin
    Menu.GrayedItem(IDM_READPREV);
    Menu.GrayedItem(IDM_READNEXT);
    Menu.GrayedItem(IDM_READPREVFILE);
    Menu.GrayedItem(IDM_READNEXTFILE);
    Menu.GrayedItem(IDM_HIDEBORDER);
    Menu.GrayedItem(IDM_INFO);
    Menu.GrayedItem(IDM_STRETCH);
    Menu.GrayedItem(IDM_FULLSCREEN);
    Menu.GrayedItem(IDM_FIT);
    Menu.GrayedItem(IDM_ZOOMIN);
    Menu.GrayedItem(IDM_ZOOMOUT);
    Menu.GrayedItem(IDM_ZOOM50);
    Menu.GrayedItem(IDM_ZOOM100);
    Menu.GrayedItem(IDM_ZOOM150);
    Menu.GrayedItem(IDM_ZOOM200);
    Menu.GrayedItem(IDM_ZOOM300);
    Menu.GrayedItem(IDM_ZOOM400);
    Menu.GrayedItemByPos(wi);
  end;

  if Stretch then
  begin
    Menu.GrayedItem(IDM_ZOOMIN);
    Menu.GrayedItem(IDM_ZOOMOUT);
  end;

  if FullScreen then
    Menu.GrayedItem(IDM_FIT);

  Menu.CheckItem(IDM_FULLSCREEN, FullScreen);
  Menu.CheckItem(IDM_STAYONTOP, StayOnTop);
  Menu.CheckItem(IDM_STRETCH, Stretch);
  Menu.CheckItem(IDM_HIDEBORDER, not Border);

  Menu.Popup(Handle);
  PluginMenu.Free;
  WallPMenu.Free;
  Menu.Free;
end;

// windowTCYGɂ킹
procedure TMainWindow.FitWindow;
var
  rc: TRect;
begin
  if not Image.Loaded then
    Exit;
  if IsZoomed(Handle) then
    ShowWindow(Handle, SW_RESTORE);
  rc := Rect(0, 0, DispWidth, DispHeight);
  AdjustWindowRect(rc, GetWindowLong(Handle, GWL_STYLE), False);
  SetSize(rc.Right-rc.Left, rc.Bottom-rc.Top);
end;

procedure TMainWindow.SetPictureInfoItem(hwndDlg: HWND);
var
  colors, path: string;
  id: Word;
  i: Integer;
begin
  with Image do
  begin
    //SendMessage(hwndDlg, WM_SETFONT, GetStockObject(DEFAULT_GUI_FONT), 1);
    //SendDlgItemMessage(hwndDlg, IDC_TEXTINFO, WM_SETFONT, GetStockObject(DEFAULT_GUI_FONT), 1);
    {
    SetWindowLong(hwndDlg, GWL_EXSTYLE, GetWindowLong(hwndDlg, GWL_EXSTYLE) or $80000);
    h := LoadLibrary('user32.dll');
    SetLayeredWindowAttributes := GetProcAddress(h, 'SetLayeredWindowAttributes');
    if Assigned(SetLayeredWindowAttributes) then
      SetLayeredWindowAttributes(hwndDlg, 0, 192, 2);
    FreeLibrary(h);
    }
    if InfoDlgIcon <> 0 then DestroyIcon(InfoDlgIcon);
    // id = 1ɂbmpŃTlCACRł͂Ȃʂ̃ACRۂ
    id := 1;
    if hAM = 0 then
    begin
      Path := ExtractFilePath(FileName);
      InfoDlgIcon := ExtractAssociatedIcon(HInstance, PChar(FileName), id);
    end else
    begin
      i := Pos(ExtractFileName(FileName), FileName);
      Path := Image.ArcFileName + '/' + Copy(FileName, 1, i-1);
      InfoDlgIcon := ExtractAssociatedIcon(HInstance, PChar(Image.ArcFileName), id);
    end;
    if ColorDepth < 32 then colors := CommaStr(1 shl ColorDepth) else colors := '';
    SetDlgItemText(hwndDlg, IDC_FILENAME, PChar(ExtractFileName(FileName)));
    SetDlgItemText(hwndDlg, IDC_LOCATION, PChar(Path));
    SetDlgItemText(hwndDlg, IDC_SIZE, PChar(IntToStr(Width)+'x'+IntToStr(Height)));
    SetDlgItemText(hwndDlg, IDC_COLORS, PChar(colors+' ('+IntToStr(ColorDepth)+' bit)'));
    SetDlgItemText(hwndDlg, IDC_FORMAT, PChar(Format));
    SetDlgItemText(hwndDlg, IDC_FILESIZE, PChar(IntToKBStr(FileSize)+' ('+CommaStr(FileSize)+' bytes)'));
    SetDlgItemText(hwndDlg, IDC_CREATED, PChar(FileTimeToLocalTimeStr(FileCTime)));
    SetDlgItemText(hwndDlg, IDC_MODIFIED, PChar(FileTimeToLocalTimeStr(FileMTime)));
    SetDlgItemText(hwndDlg, IDC_ACCESSED, PChar(FileTimeToLocalTimeStr(FileATime)));
    SetDlgItemText(hwndDlg, IDC_MEMORY, PChar(IntToKBStr(MemSize)+' ('+CommaStr(MemSize)+' bytes)'));
    SetDlgItemText(hwndDlg, IDC_PLUGIN, PChar(SPIName));
    SetDlgItemText(hwndDlg, IDC_PLUGINFILE, PChar(SPIFilename));
    EnableWindow(GetDlgItem(hwndDlg, IDC_TEXTINFOLABEL), Memo <> '');
    SetDlgItemText(hwndDlg, IDC_TEXTINFO, PChar(Memo));
    InvalidateRect(hwndDlg, nil, True);
    //Result := 0;
  end;
end;

procedure TMainWindow.OnDropFiles(hDrop: HDROP);
var
  FileName: array[0..MAX_PATH-1] of Char;
begin
  DragQueryFile(hDrop, 0, filename, SizeOf(filename));
  DragFinish(hDrop);
  if ReadNewFile(filename, False) = 0 then
  begin
    FileList.Clear; // Vt@Cǂݍ񂾂̂Ńt@CXgNA
    InvalidateRect(Handle, nil, False);
  end else
    MessageBox(MainWindow.Handle, PChar(FileName + #13#10 + err_unknownformat),
      AppName, MB_ICONEXCLAMATION);
end;

procedure TMainWindow.OnPaint;
var
  dc: HDC;
  ps: TPaintStruct;
  brush: HBrush;
  rc: TRect;
  r, b, fx, fy: Integer;
  bi: TMaxBitmapInfo;
  p: Pointer;
  //s: string;
  //rr, t: Integer;
  //rgn: HRGN;
  //rc2: TRect;
begin
  dc := BeginPaint(Handle, ps);
  rc := ClientRect;
  brush := GetStockObject(GRAY_BRUSH);

  // [hĂȂ΃O[ɓhĂ܂
  if not Image.Loaded then
  begin
    FillRect(dc, rc, brush);
    EndPaint(Handle, ps);
    Exit;
  end;

  if Stretch then
  begin
    with Image do
    begin
      if Width*rc.Bottom > Height*rc.Right then begin
        DispWidth := rc.Right;
        DispHeight := (Height * DispWidth) div Width;
      end
      else begin
        DispHeight := rc.Bottom;
        DispWidth := (Width * DispHeight) div Height;
      end;
    end;
  end;

  fx := 0;
  fy := 0;
  if FullScreen then
  begin
    fx := (GetSystemMetrics(SM_CXSCREEN)-DispWidth) div 2;
    if fx < 0 then fx := 0;
    fy := (GetSystemMetrics(SM_CYSCREEN)-DispHeight) div 2;
    if fy < 0 then fy := 0;
  end;
  SetViewportOrgEx(dc, fx, fy, nil);

  with Image do
  begin
    if rc.Right > DispWidth then r := DispWidth else r := rc.Right;
    if rc.Bottom > DispHeight then b := DispHeight else b := rc.Bottom;
    if (Zoom = 100) and not Stretch then begin
      SetDIBitsToDevice(dc, 0, 0, r, b,
        Left, BitmapInfo.bmiHeader.biHeight-b, Top, BitmapInfo.bmiHeader.biHeight,
        pBits, PBitmapInfo(@BitmapInfo)^, DIB_RGB_COLORS);
    end
    else begin
      {
      GetClipRgn(dc, rgn);
      rr := GetRgnBox(rgn, rc2);
      DeleteObject(rgn);
      if rr = SIMPLEREGION then
        SetWindowText(Wnd, 'simple')
      else if rr = COMPLEXREGION then
        SetWindowText(Wnd, 'not simple');
      }
      (*
      t := GetTickCount;
      ResizeDIB(@Bi, Pointer(p), DispWidth, DispHeight,
        Left+ps.rcPaint.Left, Top+ps.rcPaint.Top,
        ps.rcPaint.Right-ps.rcPaint.Left, ps.rcPaint.Bottom - ps.rcPaint.Top,
        PBitmapInfo(@BitmapInfo)^, pBits);
      t := GetTickCount - t;

      with ps.rcPaint do
        s := IntToStr(Left) + ',' + IntToStr(Top) + '-' +
          IntToStr(Right) + ',' + IntToStr(Bottom) + '('+inttostr(t);
      SetWindowText(Wnd, pchar(s));

      SetDIBitsToDevice(dc, ps.rcPaint.Left, ps.rcPaint.Top, ps.rcPaint.Right-ps.rcPaint.Left, b,
        0, 0, 0, Bi.bmiHeader.biHeight, p, PBitmapInfo(@Bi)^, DIB_RGB_COLORS);
      //SetDIBitsToDevice(dc, 0, 0, r, b,
      //  0, 0, 0, Bi.bmiHeader.biHeight, p, PBitmapInfo(@Bi)^, DIB_RGB_COLORS);
      *)

      ResizeDIB(@Bi, Pointer(p), DispWidth, DispHeight, Left, Top,
        rc.Right, rc.Bottom,
       // r, b,
        PBitmapInfo(@BitmapInfo)^, pBits);
      SetDIBitsToDevice(dc, 0, 0, r, b,
        0, 0, 0, Bi.bmiHeader.biHeight, p, PBitmapInfo(@Bi)^, DIB_RGB_COLORS);

      FreeMem(p);
    end;
  end;

  with Image do begin
    // ܂ʂʂ
    if rc.right > DispWidth then begin
      FillRect(dc, Rect(rc.right, 0, DispWidth, DispHeight), brush);
      FillRect(dc, Rect(-fx, -fy, 0, DispHeight+fy+1), brush);
    end;
    if rc.bottom > DispHeight then begin
      FillRect(dc, Rect(0, rc.bottom, rc.Right, DispHeight), brush);
      FillRect(dc, Rect(0, -fy, rc.Right, 0), brush);
    end;
  end;

  EndPaint(Handle, ps);
end;

procedure TMainWindow.ShowAbout;
var
  mbp: TMsgBoxParams;
begin
  FillChar(mbp, SizeOf(mbp), 0);
  with mbp do begin
    cbSize      := SizeOf(mbp);
    hwndOwner   := Handle;
    hInstance   := MainInstance;
    lpszText    := PChar(AppName+' '+Version+#13#10#13#10+Copyright+#13#10+'Profile Folder: '+ProfDir);
    lpszCaption := 'About '+AppName;
    dwStyle     := MB_USERICON;
    lpszIcon    := PChar(1);
  end;
  MessageBoxIndirect(mbp);
end;

procedure TMainWindow.ZoomImage(Value: Integer);
var
  rc: TRect;
begin
  if (Value > 0) and (not Stretch) then
  begin
    with Image do
    begin
      Left := Left * 100 div Zoom;
      Top  := Top * 100 div Zoom;
      Zoom := Value;
      DispWidth := Width * Zoom div 100;
      DispHeight := Height * Zoom div 100;
      Left := Left * Zoom div 100;
      Top  := Top * Zoom div 100;
      // ʒu
      rc := ClientRect;
      if DispWidth > rc.Right then
      begin
       if Left+rc.Right > DispWidth then Left := DispWidth - rc.Right;
      end else
        Left := 0;
      if DispHeight > rc.Bottom then
      begin
        if Top+rc.Bottom > DispHeight then Top := DispHeight - rc.Bottom;
      end else
         Top := 0;
    end;
  end;
  SetTitle;
  InvalidateRect(Handle, nil, False);
end;

// x, y: ړ
procedure TMainWindow.ScrollImage(x, y: Integer);
var
  rc: TRect;
  oldleft, oldtop: Integer;
//  dc: HDC;  rgn: HRGN;   rrc:TRECT;
begin
  with Image do
  begin
    if not Loaded then exit;
    rc := ClientRect;
    oldleft := Left;
    oldtop := Top;

    if DispWidth > rc.Right then begin
      Inc(Left, x);
      if Left < 0 then Left := 0;
      if (Left > DispWidth - rc.Right) then
         Left := DispWidth - rc.Right;
    end;
    if DispHeight > rc.Bottom then begin
      Inc(Top, y);
      if Top < 0 then Top := 0;
      if Top > DispHeight - rc.Bottom then
        Top := DispHeight - rc.Bottom;
    end;
    if ScrollWindow(Handle, (oldleft-Left), (oldtop-Top), nil, @rc) then
      UpdateWindow(Handle);
    //InvalidateRect(hWnd, nil, False);

{
    dc := GetDC(hWnd);
    ScrollDC(dc, (oldleft-Left), (oldtop-Top), rc, rc, 0, @rrc);
    ReleaseDC(hWnd, dc);
    InvalidateRect(hWnd, @rrc, False);
}
  end;
end;

procedure TMainWindow.SetFullScreen(Value: Boolean);
begin
  FFullScreen := Value;
  if FFullScreen then
  begin
    FillChar(SaveWP, SizeOf(SaveWP), 0);
    SaveWP.length := SizeOf(SaveWP);
    GetWindowPlacement(Handle, @SaveWP);
    SaveWS := GetWindowLong(Handle, GWL_STYLE);
    SetWindowLong(Handle, GWL_STYLE, WS_OVERLAPPEDWINDOW
      and not WS_CAPTION and not WS_THICKFRAME and not WS_SYSMENU);

    ShowWindow(Handle, SW_SHOWNA);
    MoveWindow(Handle, 0, 0, GetSystemMetrics(SM_CXSCREEN),
      GetSystemMetrics(SM_CYSCREEN), True);

    //ShowWindow(hWnd, SW_SHOWMAXIMIZED);
  end
  else begin
    SetWindowLong(Handle, GWL_STYLE, SaveWS and not WS_MAXIMIZE);
    ShowWindow(Handle, SW_SHOWNA);
    SetWindowPlacement(Handle, @SaveWP);
  end;
end;

procedure TMainWindow.SetBorder(Value: Boolean);
var
  rc: TRect;
begin
  FBorder := Value;
  if FBorder then
    SetWindowLong(Handle, GWL_STYLE, WS_OVERLAPPEDWINDOW)
  else
    SetWindowLong(Handle, GWL_STYLE, WS_OVERLAPPEDWINDOW
      and not WS_CAPTION and not WS_THICKFRAME and not WS_SYSMENU);
  ShowWindow(Handle, SW_SHOWNA);
  rc := ClientRect;
  AdjustWindowRect(rc, GetWindowLong(Handle, GWL_STYLE), False);
  SetSize(rc.Right-rc.Left, rc.Bottom-rc.Top);
end;

procedure TMainWindow.OnCommand(Cmd: Integer);
var
  i: Integer;
  s, ss: string;
  h: HMODULE;
  rc: TRect;
begin
  if Image.Loaded then
  begin
    case cmd of
      IDM_INFO:
        if not (IsWindow(InfoDlg) and IsWindowVisible(InfoDlg)) then
          InfoDlg := CreateDialogParam(hInstance, 'INFODIALOG', Handle, @InfoDlgProc, 0);
      IDM_FIT:
        if not FullScreen then FitWindow;
      IDM_ZOOMIN:
        begin
          Stretch := False;
          ZoomImage(GetNextZoom(Zoom));
        end;
      IDM_ZOOMOUT:
        begin
          Stretch := False;
          ZoomImage(GetPrevZoom(Zoom));
        end;
      IDM_ZOOMSTART..IDM_ZOOMEND:
        begin
          Stretch := False;
          ZoomImage(cmd - IDM_ZOOMSTART);
        end;
      IDM_FULLSCREEN:
        FullScreen := not FullScreen;
      IDM_WALLP:
        SetWallPaper(False);
      IDM_WALLPTILE:
        SetWallPaper(True);
      IDM_STRETCH:
        begin
          Stretch := not Stretch;
          Left := 0;
          Top := 0;
          ZoomImage(Zoom);
        end;
      IDM_READNEXT:
        ReadNextFile(False);
      IDM_READPREV:
        ReadPrevFile(False);
      IDM_READNEXTFILE:
        ReadNextFile(True);
      IDM_READPREVFILE:
        ReadPrevFile(True);
      IDM_SMOOTHZOOMIN:
        for i := 0 to 4 do begin
          ZoomImage(Zoom+1);
          UpdateWindow(Handle);
        end;
      IDM_SMOOTHZOOMOUT:
        for i := 0 to 4 do begin
          ZoomImage(Zoom-1);
          UpdateWindow(Handle);
        end;
      IDM_HIDEBORDER:
        if not FullScreen then
          Border := not Border;
      IDM_REFRESHFILELIST:
        FileList.Clear;
      IDM_SCROLLTOP:
        ScrollImage(0, -DispHeight);
      IDM_SCROLLBOTTOM:
        ScrollImage(0, DispHeight);
      IDM_SCROLLTOPBOTTOM:
        begin
          rc := ClientRect;
          if Top = DispHeight - rc.Bottom then
            ScrollImage(0, -DispHeight)
          else
            ScrollImage(0, DispHeight);
        end;
      IDM_SCROLLLEFT:  ScrollImage(-Scroll,0);
      IDM_SCROLLRIGHT: ScrollImage(Scroll, 0);
      IDM_SCROLLUP:    ScrollImage(0,-Scroll);
      IDM_SCROLLDOWN:  ScrollImage(0, Scroll);
      IDM_ARCHIVEFILELIST:
        begin
          for i := 0 to ArcFileList.ItemCount - 1 do
            s := s + PChar(ArcFileList[i]) + #13#10;
          MessageBox(Handle, PChar(s), AppName + '', 0);
        end;
    end;
  end;
  case cmd of
    IDM_STAYONTOP:
      StayOnTop := not StayOnTop;
    IDM_PLUGINLIST:
      begin
        s := IntToStr(Image.PluginList.Count) + ' plugin(s) found.'#13#10#13#10;
        for i := 0 to Image.PluginList.Count - 1 do
        begin
          h := LoadLibrary(PChar(Image.PluginList[i]));
          if h = 0 then
            ss := '(not found)'
          else begin
            ss := GetPluginName(h);
            FreeLibrary(h);
          end;
          s := s + PChar(Image.PluginList[i]) + ': ' + ss + #13#10;
        end;
        MessageBox(Handle, PChar(s), 'Plug-in List', MB_OK);
      end;
    IDM_PLUGINSETTING_START .. IDM_PLUGINSETTING_END:
      ConfigDlg(Handle, Image.PluginList[cmd - IDM_PLUGINSETTING_START]);
    IDM_ABOUT:
      ShowAbout;
    IDM_EXIT:
      Close;
  end;
end;

procedure TMainWindow.WndProc(var Message: TMessage);
var
  pt: TPoint;
  x, y: Integer;
begin
  with Message do
  begin
    Result := 0;
    if (Msg = WM_MOUSEWHEEL) or ((Msg = MsgMouseWheel) and (MsgMouseWheel <> 0)) then
    begin
      if (GetKeyState(VK_LBUTTON) < 0) and not Stretch then
      begin
        if wParam > 0 then
          OnCommand(IDM_SMOOTHZOOMIN)
        else
          OnCommand(IDM_SMOOTHZOOMOUT)
      end
      else begin
        if wParam > 0 then
          OnCommand(IDM_READPREV)
        else
          OnCommand(IDM_READNEXT);
      end;
      Exit;
    end;
    case Msg of
      WM_DROPFILES:
        OnDropFiles(wParam);
      WM_PAINT:
        OnPaint;
      WM_COMMAND:
        OnCommand(LoWord(wParam));
      WM_NCHITTEST:
        if Border or FullScreen then
          inherited
        else
          Result := HTCAPTION;
      WM_LBUTTONDOWN:
        begin
          SetCapture(Handle);
          SetCursor(GrabCursor);
          GetCursorPos(pt);
          oldpt := pt;
        end;
      WM_LBUTTONUP:
        begin
          ReleaseCapture;
          SetCursor(NormalCursor);
        end;
      WM_LBUTTONDBLCLK:
        if not FullScreen then FitWindow;
      WM_RBUTTONUP:
        PopupMenu;
      WM_NCRBUTTONUP:
        if not Border then PopupMenu;
      WM_NCLBUTTONDBLCLK:
        if (not FullScreen) and (not Border) then
          FitWindow
        else
          inherited;
      WM_MOUSEMOVE:
        begin
          // StretchŃXN[悤ƂĂcaption_uNbN
          // ő剻悤ƂƗ̂Stretch ModêƂ͉Ȃ
          if Image.Loaded and (wParam = MK_LBUTTON) and not Stretch then
          begin
            GetCursorPos(pt); // ƂȂ window ÔƂWƂȂ
            ScrollImage(oldpt.x - pt.x, oldpt.y - pt.y);
            oldpt := pt;
          end;
        end;
      WM_SIZE:
        with Image do begin
          if Loaded and not Stretch then begin
            x := LoWord(lParam);
            y := HiWord(lParam);
            if DispWidth > x then begin
              if Left+x > DispWidth then
                Left := DispWidth - x;
            end else
              Left := 0;
            if DispHeight > y then begin
              if Top+y > DispHeight then
                Top := DispHeight - y;
            end else
              Top := 0;
          end;
        end;
      WM_CLOSE:
        DestroyWindow(Handle);
      WM_DESTROY:
        PostQuitMessage(0);
    else
      inherited;
    end;
  end;
end;

procedure LoadConfig;
var
  ConfFile: TConfFile;
begin
  ConfFile := TConfFile.Create(ProfDir + ConfigFile);
  while ConfFile.GetLine do
  begin
    with ConfFile.Line do
    begin
      if Name = 'KeepViewPosition' then
        KeepViewPositon := StrToBool(Args[0]);
    end;
  end;
  ConfFile.Free;
end;

var
  Msg: TMsg;
  r: Integer;
begin
  ProfDir := GetProfDir('nkv');
  LoadConfig;

  KeyTbl := TKeyTable.Create(Cmds, DefaultKeys, ProfDir + KeyMapFile);

  FileMode := 0; // Reset  read only mode ŊJ

  MainWindow := TMainWindow.Create(AppName);
  with MainWindow do
  begin
    NormalCursor := LoadCursor(HInstance, 'HANDOPEN');
    GrabCursor := LoadCursor(HInstance, 'HANDHOLD');
    Cursor := NormalCursor;
    ClassStyle := CS_HREDRAW or CS_VREDRAW or CS_DBLCLKS;
    ExStyle := WS_EX_ACCEPTFILES;
    FBorder := True;
    Brush := GetStockObject(NULL_BRUSH);
    CreateWnd(CW_USEDEFAULT, 0, 320, 240);
    if Handle = 0 then
      Halt(255);

    FileList := TFileList.Create;
    ArcFileList := TFileList.Create;
    TmpArcFileList := TFileList.Create;
    Image := TNkVImage.Create;

    try
      if not FileExist(ProfDir + PluginListFile) then
      begin
        if MakePluginListFile <> 0 then
          MessageBox(GetDesktopWindow,
            PChar(ProfDir + PluginListFile + ': ' + err_cantwrite),
            AppName, MB_ICONEXCLAMATION);
      end;
      LoadPluginListFile;

      if ParamStr(1) <> '' then
      begin
        r := ReadNewFile(GetLongFileName(ParamStr(1)), False);
        if r <> 0 then
        begin
          MessageBox(GetDesktopWindow,
            PChar(GetLongFileName(ParamStr(1)) + #13#10 + err_unknownformat),
            AppName, MB_ICONEXCLAMATION);
          Close;
          Exit;
        end
      end;

      Show;

      while Integer(GetMessage(Msg, 0, 0, 0)) <> 0 do
      begin
        if (InfoDlg = 0) or not IsDialogMessage(InfoDlg, Msg) then
        begin
          if not Boolean(TranslateAccelerator(Handle, KeyTbl.AccHandle, Msg)) then
          begin
            TranslateMessage(Msg);
            DispatchMessage(Msg);
          end;
        end;
      end;
      ExitCode := Msg.wParam;
    finally
      Image.Free;
      FileList.Free;
      ArcFileList.Free;
      TmpArcFileList.Free;
      KeyTbl.Free;
    end;
  end;
  MainWindow.Free;
end.

